#ifndef MATRIX_H
#define MATRIX_H

#include <iostream>
using std::ostream;
using std::istream;

#include "Row.h"

class Matrix
{
    public:
    Matrix(int=1,int=1,double=0);
    Matrix(const Matrix&);
    ~Matrix();
    Row &operator[](int);
    const Row &operator[](int) const;
    Matrix &operator+(Matrix&);
    Matrix &operator+=(Matrix&);

    Matrix operator*(Matrix&);
    Matrix &operator*=(Matrix&);

    friend Matrix &operator*(Matrix&, const double);
    friend Matrix &operator*=(Matrix&, const double);
    friend Matrix operator*(const double, const Matrix &);

    Matrix &operator-(Matrix&);
    Matrix &operator-=(Matrix&);
    Matrix &operator=(const Matrix&);
    Matrix operator/(Matrix&);
    Matrix operator/=(Matrix&);
    bool operator==(const Matrix&);
    bool operator!=(const Matrix&);
    double det();
    Matrix inverted();
    Matrix transposed();

    private:
    void swap(Row&,Row&);
    void resize(int=1,int=1,double=0);
    Row *matrix;
    int row; // 
    int column; // 
};

#endif
